
DeadlySlackers = LibStub("AceAddon-3.0"):NewAddon("DeadlySlackers", "AceConsole-3.0")
local AceGUI = LibStub("AceGUI-3.0")
function DeadlySlackers:OnInitialize()

	addonSettings = LibStub("AceDB-3.0"):New("DeadlySlackersConfig", DEFAULT_SETTINGS);
	addonSettings.RegisterCallback(self, "OnProfileChanged", "RefreshConfig")
end

--local readLog = CreateFrame("FRAME", "CombatReader");
local enterCombat = CreateFrame("FRAME", "EnterCombat");
local updateFrame = CreateFrame("FRAME");
encounterMainTargets = {}
showFrame = CreateFrame("ScrollFrame", "NameList");
enterCombat:RegisterEvent("ENCOUNTER_START");
--readLog:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
DeadlySlackers_UpdateInterval = 1.0; -- How often the OnUpdate code will run (in seconds)
DeadlySlackers_LastUpdated = 2.0;
groupTable = {"1", "2"};
showFrame:SetFrameStrata("BACKGROUND")
showFrame:SetWidth(64) -- Set these to whatever height/width is needed 
showFrame:SetHeight(0);
classColors = {"|cffc79c6e", "|cfff58cba", "|cffabd473", "|cfffff569", "|cffffffff", "|cffc41f3b", "|cff0070de", "|cff69ccf0", "|cff9482c9", "|cff00ff96", "|cffff7d0a"}
local bgTexture = showFrame:CreateTexture(nil,"BACKGROUND")
bgTexture:SetTexture(0.66, 0.66, 0.66, 0.5);
bgTexture:SetAllPoints(showFrame)
showFrame.texture = bgTexture
showFrame:SetMovable(true);
showFrame:EnableMouse(true);
showFrame:RegisterForDrag("LeftButton");
showFrame:SetScript("OnDragStart", showFrame.StartMoving);
showFrame:SetScript("OnDragStop", showFrame.StopMovingOrSizing);
showFrame:SetPoint("CENTER",0,0)
DeadlySlackers:RegisterChatCommand("dsconfig", "drawOptionsFrame")
noSlackTarget = {"1"};
function DeadlySlackers:drawOptionsFrame()
local optionsFrame = AceGUI:Create("Frame")
optionsFrame:SetTitle("DeadlySlackers")
optionsFrame:SetStatusText("Leave empty to see who isn't targeting your target.")
optionsFrame:SetCallback("OnClose", function(widget) AceGUI:Release(widget) end)
optionsFrame:SetLayout("Flow")

local editbox1 = AceGUI:Create("EditBox")
editbox1:SetLabel("Hellfire Assault Tracked Target:")
editbox1:SetWidth(200)
editbox1:SetCallback("OnEnterPressed", function(widget, event, text) if text ~= nil then addonSettings.char.hellfireAssaultMainTarget = {}; for word in string.gmatch(text, "([^,]+)") do table.insert(addonSettings.char.hellfireAssaultMainTarget, word)end end end)
if addonSettings.char.hellfireAssaultMainTarget ~= nil then editbox1:SetText(table.concat(addonSettings.char.hellfireAssaultMainTarget, ","))end
optionsFrame:AddChild(editbox1)

local editbox2 = AceGUI:Create("EditBox")
editbox2:SetLabel("Iron Reaver Tracked Target:")
editbox2:SetWidth(200)
editbox2:SetCallback("OnEnterPressed", function(widget, event, text) if text ~= nil then addonSettings.char.ironReaverMainTarget = {}; for word in string.gmatch(text, "([^,]+)") do table.insert(addonSettings.char.ironReaverMainTarget, word)end end end)
if addonSettings.char.ironReaverMainTarget ~= nil then editbox2:SetText(table.concat(addonSettings.char.ironReaverMainTarget, ","))end
optionsFrame:AddChild(editbox2)

local editbox3 = AceGUI:Create("EditBox")
editbox3:SetLabel("Kormrok Tracked Target:")
editbox3:SetWidth(200)
editbox3:SetCallback("OnEnterPressed", function(widget, event, text) if text ~= nil then addonSettings.char.kormrokMainTarget = {}; for word in string.gmatch(text, "([^,]+)") do table.insert(addonSettings.char.kormrokMainTarget, word)end end end)
if addonSettings.char.kormrokMainTarget ~= nil then editbox3:SetText(table.concat(addonSettings.char.kormrokMainTarget, ","))end
optionsFrame:AddChild(editbox3)

local editbox4 = AceGUI:Create("EditBox")
editbox4:SetLabel("Hellfire High Council Tracked Target:")
editbox4:SetWidth(200)
editbox4:SetCallback("OnEnterPressed", function(widget, event, text) if text ~= nil then addonSettings.char.councilMainTarget = {}; for word in string.gmatch(text, "([^,]+)") do table.insert(addonSettings.char.councilMainTarget, word)end end end)
if addonSettings.char.councilMainTarget ~= nil then editbox4:SetText(table.concat(addonSettings.char.councilMainTarget, ","))end
optionsFrame:AddChild(editbox4)

local editbox5 = AceGUI:Create("EditBox")
editbox5:SetLabel("Kilrogg Deadeye Tracked Target:")
editbox5:SetWidth(200)
editbox5:SetCallback("OnEnterPressed", function(widget, event, text) if text ~= nil then addonSettings.char.kilroggMainTarget = {}; for word in string.gmatch(text, "([^,]+)") do table.insert(addonSettings.char.kilroggMainTarget, word)end end end)
if addonSettings.char.kilroggMainTarget ~= nil then editbox5:SetText(table.concat(addonSettings.char.kilroggMainTarget, ","))end
optionsFrame:AddChild(editbox5)

local editbox6 = AceGUI:Create("EditBox")
editbox6:SetLabel("Gorefiend Tracked Target:")
editbox6:SetWidth(200)
editbox6:SetCallback("OnEnterPressed", function(widget, event, text) if text ~= nil then addonSettings.char.gorefiendMainTarget = {}; for word in string.gmatch(text, "([^,]+)") do table.insert(addonSettings.char.gorefiendMainTarget, word)end end end)
if addonSettings.char.gorefiendMainTarget ~= nil then editbox6:SetText(table.concat(addonSettings.char.gorefiendMainTarget, ","))end
optionsFrame:AddChild(editbox6)

local editbox7 = AceGUI:Create("EditBox")
editbox7:SetLabel("Shadow Lord Iskar Tracked Target:")
editbox7:SetWidth(200)
editbox7:SetCallback("OnEnterPressed", function(widget, event, text) if text ~= nil then addonSettings.char.iskarMainTarget = {}; for word in string.gmatch(text, "([^,]+)") do table.insert(addonSettings.char.iskarMainTarget, word)end end end)
if addonSettings.char.iskarMainTarget ~= nil then editbox7:SetText(table.concat(addonSettings.char.iskarMainTarget, ","))end
optionsFrame:AddChild(editbox7)

local editbox8 = AceGUI:Create("EditBox")
editbox8:SetLabel("Socrethar the Eternal Tracked Target:")
editbox8:SetWidth(200)
editbox8:SetCallback("OnEnterPressed", function(widget, event, text) if text ~= nil then addonSettings.char.socretharMainTarget = {}; for word in string.gmatch(text, "([^,]+)") do table.insert(addonSettings.char.socretharMainTarget, word)end end end)
if addonSettings.char.socretharMainTarget ~= nil then editbox8:SetText(table.concat(addonSettings.char.socretharMainTarget, ","))end
optionsFrame:AddChild(editbox8)

local editbox9 = AceGUI:Create("EditBox")
editbox9:SetLabel("Fel Lord Zakunn Tracked Target:")
editbox9:SetWidth(200)
editbox9:SetCallback("OnEnterPressed", function(widget, event, text) if text ~= nil then addonSettings.char.zakuunMainTarget = {}; for word in string.gmatch(text, "([^,]+)") do table.insert(addonSettings.char.zakuunMainTarget, word)end end end)
if addonSettings.char.zakuunMainTarget ~= nil then editbox9:SetText(table.concat(addonSettings.char.zakuunMainTarget, ","))end
optionsFrame:AddChild(editbox9)

local editbox10 = AceGUI:Create("EditBox")
editbox10:SetLabel("Xhul'Horac Tracked Target:")
editbox10:SetWidth(200)
editbox10:SetCallback("OnEnterPressed", function(widget, event, text) if text ~= nil then addonSettings.char.xhulMainTarget = {}; for word in string.gmatch(text, "([^,]+)") do table.insert(addonSettings.char.xhulMainTarget, word)end end end)
if addonSettings.char.xhulMainTarget ~= nil then editbox10:SetText(table.concat(addonSettings.char.xhulMainTarget, ","))end
optionsFrame:AddChild(editbox10)

local editbox11 = AceGUI:Create("EditBox")
editbox11:SetLabel("Tyrant Velhari Tracked Target:")
editbox11:SetWidth(200)
editbox11:SetCallback("OnEnterPressed", function(widget, event, text) if text ~= nil then addonSettings.char.tyrantMainTarget = {}; for word in string.gmatch(text, "([^,]+)") do table.insert(addonSettings.char.tyrantMainTarget, word)end end end)
if addonSettings.char.tyrantMainTarget ~= nil then editbox11:SetText(table.concat(addonSettings.char.tyrantMainTarget, ","))end
optionsFrame:AddChild(editbox11)

local editbox12 = AceGUI:Create("EditBox")
editbox12:SetLabel("Mannoroth Tracked Target:")
editbox12:SetWidth(200)
editbox12:SetCallback("OnEnterPressed", function(widget, event, text) if text ~= nil then addonSettings.char.mannorothMainTarget = {}; for word in string.gmatch(text, "([^,]+)") do table.insert(addonSettings.char.mannorothMainTarget, word)end end end)
if addonSettings.char.mannorothMainTarget ~= nil then editbox12:SetText(table.concat(addonSettings.char.mannorothMainTarget, ","))end
optionsFrame:AddChild(editbox12)

local editbox13 = AceGUI:Create("EditBox")
editbox13:SetLabel("Archimonde Tracked Target:")
editbox13:SetWidth(200)
editbox13:SetCallback("OnEnterPressed", function(widget, event, text) if text ~= nil then addonSettings.char.archimondeMainTarget = {}; for word in string.gmatch(text, "([^,]+)") do table.insert(addonSettings.char.archimondeMainTarget, word)end end end)
if addonSettings.char.archimondeMainTarget ~= nil then editbox13:SetText(table.concat(addonSettings.char.archimondeMainTarget, ","))end
optionsFrame:AddChild(editbox13)
---------------------------------------------------------------------------------
end
local DEFAULT_SETTINGS = {
	char = {
	
		hellfireAssaultMainTarget = {},
		ironReaverMainTarget = {},
		kormrokMainTarget = {},
		councilMainTarget = {},
		kilroggMainTarget = {},
		gorefiendMainTarget = {},
		iskarMainTarget = {},
		socretharMainTarget = {},
		zakuunMainTarget = {},
		tyrantMainTarget = {},
		xhulMainTarget = {},
		mannorothMainTarget = {},
		archimondeMainTarget = {}
				
	}
 }
function DeadlySlackers:OnEnable()
	DeadlySlackers:Print("Use /dsconfig to access config window.")
	encounterMainTargets[1778] = addonSettings.char.hellfireAssaultMainTarget
	encounterMainTargets[1785] = addonSettings.char.ironReaverMainTarget
	encounterMainTargets[1787] = addonSettings.char.kormrokMainTarget
	encounterMainTargets[1798] = addonSettings.char.councilMainTarget
	encounterMainTargets[1786] = addonSettings.char.kilroggMainTarget
	encounterMainTargets[1783] = addonSettings.char.gorefiendMainTarget
	encounterMainTargets[1788] = addonSettings.char.iskarMainTarget
	encounterMainTargets[1800] = addonSettings.char.xhulMainTarget
	encounterMainTargets[1777] = addonSettings.char.zakuunMainTarget
	encounterMainTargets[1794] = addonSettings.char.socretharMainTarget
	encounterMainTargets[1784] = addonSettings.char.tyrantMainTarget
	encounterMainTargets[1795] = addonSettings.char.mannorothMainTarget
	encounterMainTargets[1799] = addonSettings.char.archimondeMainTarget
end
function DeadlySlackers:OnDisable()

end
function DeadlySlackers:RefreshConfig()
	encounterMainTargets[1778] = addonSettings.char.hellfireAssaultMainTarget
	encounterMainTargets[1785] = addonSettings.char.ironReaverMainTarget
	encounterMainTargets[1787] = addonSettings.char.kormrokMainTarget
	encounterMainTargets[1798] = addonSettings.char.councilMainTarget
	encounterMainTargets[1786] = addonSettings.char.kilroggMainTarget
	encounterMainTargets[1783] = addonSettings.char.gorefiendMainTarget
	encounterMainTargets[1788] = addonSettings.char.iskarMainTarget
	encounterMainTargets[1800] = addonSettings.char.xhulMainTarget
	encounterMainTargets[1777] = addonSettings.char.zakuunMainTarget
	encounterMainTargets[1794] = addonSettings.char.socretharMainTarget
	encounterMainTargets[1784] = addonSettings.char.tyrantMainTarget
	encounterMainTargets[1795] = addonSettings.char.mannorothMainTarget
	encounterMainTargets[1799] = addonSettings.char.archimondeMainTarget
end
function inTable(tbl, item)
    for key, value in pairs(tbl) do
        if value == item then return key end
    end
    return false
end
local slackerFS = showFrame:CreateFontString(nil, "OVERLAY",  "GameFontNormalSmall");
slackerFS:SetPoint("TOPLEFT");



local function combatEnterFunction(self, event, ...)
local encounterID, encounterName, diffID, raidSize = ...;

noSlackTarget = encounterMainTargets[encounterID];
groupTable = {}
for i = 1, 40 do groupTable[i] = UnitName("raid".. i) end

end
--[[
local function logReadFunction(self, event, ...)

if event == "COMBAT_LOG_EVENT_UNFILTERED" then

  local timestamp, combatEvent, combatBool, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags = 
   ...; 
   local eventPrefix, eventSuffix = combatEvent:match("^(.-)_?([^_]*)$");
   if string.sub (sourceGUID, 1, 6) == "Player" then
  
  if eventSuffix == "DAMAGE" then
  

   local amount, overkill, school, resisted, blocked, absorbed, critical, glancing, crushing = 
    select(select("#", ...)-8, ...); 
	
	
   end
   
  end
 end
 

 end
 ]]--


-- Functions Section
function DeadlySlackers_OnUpdate(self, elapsed)

   	DeadlySlackers_LastUpdated = DeadlySlackers_LastUpdated + elapsed;
groupTargets = {}
groupSlackers = {}
  if (DeadlySlackers_LastUpdated > DeadlySlackers_UpdateInterval) then
	listString = ""
	if noSlackTarget == nil or string.len(table.concat(noSlackTarget, "")) > 1 then
    noSlackTarget = {UnitName("target")};
	end
	slackerFrameTable = {}
    for i = 1, 40 do groupTargets[i] = UnitName("raid".. i .."target");	end
	for i = 1, 40 do 
	role = UnitGroupRolesAssigned("raid".. i);
	if (UnitIsDead("raid".. i) == false and inTable(noSlackTarget, groupTargets[i]) == false and role == "DAMAGER") then groupSlackers[i] = groupTable[i]; end 
	if (groupSlackers[i] ~= nil) then
	local localizedClass, englishClass, classIndex = UnitClass("raid".. i);
	table.insert(slackerFrameTable, 1, classColors[classIndex] .."".. groupTable[i] .."|r");
	end
	end
	if slackerFrameTable[1] == nil then showFrame:SetHeight(0); else
	listString = table.concat(slackerFrameTable, "\n");
	slackerFS:SetText(listString);
	showFrame:SetHeight(slackerFS:GetStringHeight()) -- for your Texture
	end
	if slackerFrameTable[1] ~= nil then
		showFrame:Show()
		else
		showFrame:Hide()
	end
	--if addonSettings.char.archimondeMainTarget ~= nil then DeadlySlackers:Print(table.concat(encounterMainTargets[1799], "\n")) end
	DeadlySlackers_LastUpdated = 0;
  end
 
end

--readLog:SetScript("OnEvent", logReadFunction);
enterCombat:SetScript("OnEvent", combatEnterFunction);
updateFrame:SetScript("OnUpdate", DeadlySlackers_OnUpdate);